// Ejemplo Clase
clear;
xdel(winsid());
clc;
s=%s;
Gp=syslin("c",10,s*(s+31.6))
zpk(Gp)
// Discretización
z=%z;
Ts=0.001;
Gp_z=ss2tf(dscr(tf2ss(Gp),Ts))
zpk(Gp_z)
// Cálculo del error
Kv=horner(Gp*s,0)
Kv=horner(Gp_z*(z-1)/Ts,1)
K1=10/Kv
// Transformación bilineal
Gp_w=ss2tf(bilin(Gp_z,[Ts/2,1,-Ts/2,1]))
zpk(Gp_w)
Gp_w1=Gp_w*K1;
// Diagrama de Bode.
xdel(winsid());
pth=pwd()
pth=pth+"\bode_lin.sci"
exec(pth)
w=logspace(-1,6,500);
frec=w/2/%pi;
[M,F,w]=bode_asym(Gp_w1,w,0,"red");

// Fución para el cálculo de la red de atraso.
function [Gc]=atraso(a,wc)
    // Cálculo de la red de atraso en función 
    // de la atenuación y la frecuencia de corte
    s=%s;
    w0=wc/10;
    wp=w0/a;
    Gc=syslin("c",1+s/w0,1+s/wp);
endfunction;

// Función para el cálculo de la red de adelanto
function [Gc]=adelanto(phi_max,w0)
    // Cálculo de la red de atraso en función 
    // de la atenuación y la frecuencia de corte
    s=%s;
    s_pm=sin(phi_max*%pi/180);
    a=(1+s_pm)/(1-s_pm)
    wp=w0*sqrt(a);
    wc=wp/a;
    Gc=syslin("c",1+s/wc,1+s/wp);
endfunction;

// Red de Adelanto
Gc1=adelanto(45,100);
//Gc1=adelanto(55,200);
zpk(Gc1)
GH1=Gp_w1*Gc1;
wx=logspace(-2,6,500);
frec=wx/2/%pi;
[fx1,rep] =repfreq(GH1,frec);// Calcula la respuesta en frecuencia
                            // en números complejos
[db,phi]=dbphi(rep); // Convierte a dB y Fase
subplot(211)
plot2d("ln",wx,db,color("scilabgreen4"));
subplot(212)
plot2d("ln",wx,phi,color("scilabgreen4"));
// Ajuste de Ganancia
xdel(winsid());
clc;
K2=10^(22.76/20)
//K2=10^(33/20)
GH2=GH1*K2;
w=logspace(-1,6,500);
frec=w/2/%pi;
[M,F,w]=bode_asym(GH2,w,0,"red");
// Transformación del Compensador
Gct=K1*K2*Gc1;
zpk(Gct)
Dz=ss2tf(bilin(Gct,[2/Ts,-2/Ts,1,1]))
zpk(Dz)
// Constante de Velocidad
Kv=horner(Gp_z*Dz*(z-1)/Ts,1)
// Sistema a lazo cerrado.
xdel(winsid());
clc;
Tlc=Gp_z*Dz/(1+Gp_z*Dz);
zpk(Tlc)
roots(Tlc.den)
Tlc_w=ss2tf(bilin(Tlc,[Ts/2,1,-Ts/2,1]))
zpk(Tlc_w)
w=logspace(-1,6,500);
frec=w/2/%pi;
[fx1,rep] =repfreq(Tlc_w,frec);// Calcula la respuesta en frecuencia
                            // en números complejos
[db,phi]=dbphi(rep); // Convierte a dB y Fase
subplot(211)
plot2d("ln",wx,db,color("scilabgreen4"));
xgrid(color("gray"))
title("Sistema a Lazo Cerrado");
subplot(212)
plot2d("ln",wx,phi,color("scilabgreen4"));
xgrid(color("gray"))
// Respuesta Transitoria
xdel(winsid())
tiempo=[0:Ts:0.2]; // Vector de Tiempos
u=ones(1,length(tiempo));
Y=dsimul(tf2ss(Tlc),u); // Simulación
plot2d(tiempo,Y,color("red"))
xgrid(color("gray"))
title('Respuesta a lazo cerrado')
